=== vendor/leatherman/catch/CMakeLists.txt ===
# Just point the user at our vendored catch. Nothing else to do here
set(${include_var} "${PROJECT_SOURCE_DIR}/vendor/catch/include" PARENT_SCOPE)
