=== ext/debian/changelog ===
facter (3.0.2-1puppetlabs1) lucid precise squeeze wheezy trusty; urgency=low

  * Update to version 

 -- Puppet Labs Release <info@puppetlabs.com>  Tue, 21 Jul 2015 10:31:33 -0700

facter (2.4.2-1puppetlabs1) lucid precise squeeze wheezy trusty; urgency=low

  * Move from Ruby to C++ implementation.

 -- Michael Smith <michael.smith@puppetlabs.com>  Fri, 20 Mar 2015 15:12:52 -0700
